﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CSharpDeps
{
    static class Utils
    {
        public static string NormalizePath(string path)
        {
            var components = path.Replace('/', '\\').Split('\\');
            var fullPath = new Stack<string>();

            foreach (var component in components)
            {
                if (component == ".")
                {
                    continue;
                }
                else if (component == "..")
                {
                    fullPath.Pop();
                }
                else
                {
                    fullPath.Push(component);
                }
            }

            return string.Join("\\", fullPath.ToArray().Reverse());
        }
    }
}
