# Installation

Run `SolidSTA\deploy\SolidSTA_install.exe` to start the installation wizard for SolidSTA and its dependencies.

# Deployment

## Dependencies

### SolidSTA

* Python 2.6 (32 bit)
	- psyco
	- py2exe
	- pysvn
	- pywin32
	- PyOpenGL
	- pypng
	- pysqlite
	- wxPython
	- *note:* The installers of all these packages are available in `.\Dependencies`

* SolidSX (http://www.solidsourceit.com/products/SolidSX-source-code-dependency-analysis.html)
* NSIS installer (http://nsis.sourceforge.net)

### SolidTFSImporter / CSharpMetrics

- Microsoft Visual Studio 2010
- .NET 4.0

## Create installer
To create the SolidSTA from scratch, after having installed all necessary dependencies, run the following two commands inside `SolidSTA\deploy`:

    .\deploy_Win32.bat
    .\create_Win32_Installer.bat

This will result in the installer `SolidSTA\deploy\SolidSTA_install.exe` being created.

## SolidTFSImporter / CSharpMetrics
Open the Solution files in Visual Studio and go to menu Build -> Build Solution. To copy `SolidTFSImporter.exe` into the support directory of SolidTA, run `.copy\_SolidTFSImporter.bat Release` ---or change `Release` to `Debug` depending on your build settings--- in the folder `SolidSTA\deploy`. This is done automatically when deploying all of SolidTA and is thus only necessary during development.

SolidTFSImporter has a dependency on both CSharpMetrics (for file-by-file analyzation of simple complexity metrics) and CSharpDeps for dependency analysis. These projects are available in a different VS solution in `.\CSharpMetrics` and have to be build first in order for SolidTFSImporter to build. The dll-files of these projects have to be added to the SolidTFSImporter project's references.

# Development

Running SolidSTA is possible without having to deploy it every single time. In `.\SolidSTA`, you can use the command `C:\Python26\python.exe -u SolidSTA.py` to start SolidSTA.
